<id>
Email Via Forum for YaBB 2.7.00
</id>

<version>
0.10
</version>

<mod info>
Description
-----------
This Mod will allow Members to send emails to other Members via the Forum.

Installation
------------
1) Modify YaBB files using YaBMod.
2) Go to 'Admin Center => Advanced Settings => Email' and check 'Enable Emails to be sent via the forum' to enable this feature.

Version History
---------------
V0.1 - First release - 5th May 2010
V0.2 - Added Member Group permissions and Member profile option - 9th May 2010
V0.3 - Added Member option to receive emails via the forum even if their email is hidden - 25th May 2010
V0.4 - Updated for YaBB 2.5 - 13th July 2010
V0.5 - Updated for YaBB 2.6.0 by Dandello - 5th July 2014
V0.6 - Updated for YaBB 2.6.1 by Dandello - 4th Sept 2014
V0.7 - Updated for YaBB 2.6.11 by Dandello - 15th Dec 2014
V0.8 - Updated for YaBB 2.7.00 by Dandello - 20th Feb 2015
V0.9 - Updated for YaBB 2.7.00 strict by Dandello - 20th Jan 2017
V0.10 - Updated for YaBB 2.7.00 strict by Dandello - 10 Mar Jan 2018 (Build 2010)
</mod info>

<author>
Derek Barnstorm, updated for 2.7.00 by Dandello
</author>

<homepage>
http://www.yabbforumsoftware.com
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    my $email_via_forum = q~Email Via Forum|Derek Barnstorm, updated for 2.7.00 by Dandello|This Mod will allow Members to send emails to other Members via the Forum.|0.10|10th Mar 2018~;
    push @installed_mods, $email_via_forum;
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
if (@newsettingspmmods) {
</search for>

<add before>
push @newsettingspmmods, 'Email via Forum';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($send_email, $send_email_group);
</add before>

<search for>
1;
EOF
</search for>

<add before>
### Email Via Forum Mod Start ###
\$send_email = $send_email;   # Set to 1 to enable members to send emails via YaBB
\$send_email_group = "\Q$send_email_group\E";   # Member Groups allowed to send emails via YaBB: '' == all members
### Email Via Forum Mod End ###

</add before>

<edit file>
Admin/Settings_Advanced.pm
</edit file>

<search for>
if (@settings_advancedpmmods) {
</search for>

<add before>
push @settings_advancedpmmods, 'Email via Forum';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($send_email, $send_email_group);
</add before>

<search for>
                name     => 'sendtopicmail',
                validate => 'number',
            },
</search for>

<add after>
        ### Email Via Forum Mod Start ###
            {
                header => $admin_txt{'send_email_1'},
            },
            {
                description => qq~<label for="send_email">$admin_txt{'send_email_2'}</label>~,
                input_html => qq~<input type="checkbox" name="send_email" id="send_email" value="1" ${ischecked($send_email)} />~,
                name => 'send_email',
                validate => 'boolean',
            },
            {
                description => qq~<label for="send_email_group">$admin_txt{'send_email_3'}</label>~,
                input_html => q~<select multiple="multiple" name="send_email_group" id="send_email_group" size="8">~ . draw_perms($send_email_group, 0) . q~</select>~,
                name => 'send_email_group',
                validate => 'text,null',
                depends_on => ['send_email'],
            },
        ### Email Via Forum Mod End ###
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
if (@englishadminlngmods) {
</search for>

<add before>
push @englishadminlngmods, 'Email via Forum';
</add before>

<search for>
1;
</search for>

<add before>
### Email Via Forum Mod Start ###
$admin_txt{'send_email_1'} = 'Member Email Settings';
$admin_txt{'send_email_2'} = 'Enable Members to send emails via the forum?';
$admin_txt{'send_email_3'} = 'Specify the Member Groups that will be enabled to send emails via the forum:<br /><span class ="small">If no Member Groups are selected all Member Groups will be enabled.<br />Use Ctrl, Shift or Apple Key to select/deselect groups.</span>';
### Email Via Forum Mod End ###
</add before>

<search for>
    '2' =>
q~Activate validation code (CAPTCHA) on registration and forgot password?~,
</search for>

<replace>
    '2' =>
q~Activate validation code (CAPTCHA) on registration, forgot password, and send email?~,
</replace>

<edit file>
Languages/English/Email.lng
</edit file>

<search for>
if (@englishemaillngmods) {
</search for>

<add before>
push @englishemaillngmods, 'Email via Forum';
</add before>

<search for>
1;
</search for>

<add before>
### Email Via Forum Mod Start ###
$sendemail = qq~<pre>Hello {yabb recipientname},

This email has been sent to you by {yabb yourname} via your account on {yabb mbname}.

If this message is spam or contains abusive or offensive content, please contact the Administrator of the Forum.

Regards,

The {yabb mbname} team
{yabb scripturl}

The message is as follows:
-----------------------------
Subject: {yabb emailsubject}
Message:
{yabb emailmessage}~;

$sendemail_selfcopy = qq~Hello {yabb yourname},

This is the requested self copy of an email which you have recently sent to {yabb recipientname} via your account on {yabb mbname}.

Regards,

The {yabb mbname} team
{yabb scripturl}

The message is as follows:
-----------------------------
Subject: {yabb emailsubject}
Message:
{yabb emailmessage}~;
### Email Via Forum Mod End ###

</add before>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
if (@englishprofilelngmods) {
</search for>

<add before>
push @englishprofilelngmods, 'Email via Forum';
</add before>

<search for>
1;
</search for>

<add before>
### Email Via Forum Mod Start ###
$profile_txt{'send_email_1'} = 'Can Members Email you via the Forum?';
$profile_txt{'send_email_2'} = '- If you hide your email from the public, by checking this option you can still allow members to email you via the forum.<br />- Members must have permission to use this feature and must also have it enabled in their profile.<br />- Your email address will be hidden from them.';
$profile_txt{'send_email_3'} = 'Send Emails via the Forum?';
$profile_txt{'send_email_4'} = 'Leave unchecked to send emails via your own email program.';
### Email Via Forum Mod End ###
</add before>

<edit file>
Sources/Display.pm
</edit file>

<search for>
if (@displaypmmods) {
</search for>

<add before>
push @displaypmmods, 'Email via Forum';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $send_email, $send_email_group, $allow_send_email );
</add before>

<search for>
        if (
            (
                   !${ $uid . $musername }{'hidemail'}
                || $iamadmin
                || $allow_hide_email != 1
                || $musername eq 'Guest'
            )
            && !$exmem
          )
        {
            if ($iamguest) { $template_email = q{}; }
            if ( $musername ne 'Guest' ) {
                $template_email =
                  $menusep
                  . enc_email( $img{'email_sm'}, $memailad, q{}, q{} ) . q{ };
            }
</search for>

<replace>
        $allow_send_email = SendEmailPerms();
        if (
            (
                   !${ $uid . $musername }{'hidemail'}
                || $iamadmin
                || $allow_hide_email != 1
                || $musername eq 'Guest'
                || (   $send_email
                    && $allow_send_email
                    && ${ $uid . $musername }{'hidemail'}
                    && ${ $uid . $musername }{'en_re_email'}
                    && ${ $uid . $username }{'en_send_email'} )
            )
            && !$exmem
          )
        {
            if ($iamguest) { $template_email = q{}; }
            if (   $send_email
                && $allow_send_email
                && ${ $uid . $username }{'en_send_email'}
                && $musername ne 'Guest' )
            {
                $template_email =
qq~$menusep<a href="$scripturl?action=sendemail;to=$useraccount{$musername}">$img{'email_sm'}</a>~;
            }
            ### Email Via Forum Mod Edit End ###
</replace>

<edit file>
Sources/Load.pm
</edit file>

<search for>
if (@loadpmmods) {
</search for>

<add before>
push @loadpmmods, 'Email via Forum';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $send_email, $send_email_group, $allow_send_email );
</add before>

<search for>
1;
</search for>

<add before>
### Email Via Forum Mod Start ###
sub SendEmailPerms {
    if ( $send_email && $send_email_group ) {
        $allow_send_email = 0;
        foreach my $email_group ( split /, /sm, $send_email_group ) {
            no strict qw(refs);
            if (   $email_group eq ${ $uid . $username }{'position'}
                || $email_group eq $memberinfo{$user} )
            {
                $allow_send_email = 1;
                last;
            }
            if ( ${ $uid . $username }{'addgroup'} ) {
                foreach ( split /,/xsm, ${ $uid . $username }{'addgroups'} ) {
                    if ( $email_group eq $_ ) { $allow_send_email = 1; last; }
                }
            }
        }
    }
    else {
        $allow_send_email = 1;
    }
    return $allow_send_email;
}
### Email Via Forum Mod End ###

</add before>

<search for>
                if ( !${ $uid . $usr }{'hidemail'} || $iamadmin ) {
                    $quicklinks .= '                <li>'
                      . enc_email(
                        "$maintxt{'1'} ${ $uid . $usr }{'realname'}",
                        ${ $uid . $usr }{'email'},
                        q{}, q{}, 1
                      ) . "</li>\n";
                }
</search for>

<replace>
                ### Email Via Forum Mod Edit Start ###
                $allow_send_email = SendEmailPerms();
                if (
                       !${ $uid . $user }{'hidemail'}
                    || $iamadmin
                    || (   $send_email
                        && $allow_send_email
                        && ${ $uid . $user }{'hidemail'}
                        && ${ $uid . $user }{'en_re_email'}
                        && ${ $uid . $username }{'en_send_email'} )
                  )
                {
                    if (   $send_email
                        && $allow_send_email
                        && ${ $uid . $username }{'en_send_email'} )
                    {
                        $quicklinks .=
qq~          <li><a href="$scripturl?action=sendemail;to=$useraccount{$user}">$maintxt{'1'} ${$uid.$user}{'realname'}</a></li>\n~;
                    }
                    else {
                        $quicklinks .= '                <li>'
                          . enc_email(
                            "$maintxt{'1'} ${ $uid . $usr }{'realname'}",
                            ${ $uid . $usr }{'email'},
                            q{}, q{}, 1
                          ) . "</li>\n";
                    }
                }
                ### Email Via Forum Mod Edit End ###
</replace>

<edit file>
Sources/MemberList.pm
</edit file>

<search for>
if (@memberlistpmmods) {
</search for>

<add before>
push @memberlistpmmods, 'Email via Forum';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $send_email, $send_email_group, $allow_send_email );
</add before>

<search for>
            if (   ${ $uid . $user }{'hidemail'}
                && !$iamadmin
                && $allow_hide_email == 1 )
            {
                $lock = qq~
            <img src="$micon_bg{'lockmail'}" alt="$ml_txt{'308'}" title="$ml_txt{'308'}" />~;
</search for>

<replace>
            ### Email Via Forum Mod Edit Start ###
            $allow_send_email = SendEmailPerms();
            if (
                (
                       !${ $uid . $user }{'hidemail'}
                    && $send_email
                    && $allow_send_email
                    && ${ $uid . $username }{'en_send_email'}
                )
                || (   ${ $uid . $user }{'hidemail'}
                    && ${ $uid . $user }{'en_re_email'}
                    && $send_email
                    && $allow_send_email
                    && ${ $uid . $username }{'en_send_email'} )
                || (   $iamadmin
                    && $send_email
                    && $allow_send_email
                    && ${ $uid . $username }{'en_send_email'} )
              )
            {
                $lock = qq~
            <a href="$scripturl?action=sendemail;to=$useraccount{$user}"><img src="$micon_bg{'email'}" alt="$img_txt{'69'}" title="$img_txt{'69'}" /></a>
            ~;
            }
            elsif (${ $uid . $user }{'hidemail'}
                && !$iamadmin
                && $allow_hide_email == 1 )
            {
                $lock = qq~
                <img src="$micon_bg{'lockmail'}" alt="$ml_txt{'308'}" title="$ml_txt{'308'}" />~;
                ### Email Via Forum Mod Edit End ###
</replace>

<edit file>
Sources/MyCenter.pm
</edit file>

<search for>
if (@mycenterpmmods) {
</search for>

<add before>
push @mycenterpmmods, 'Email via Forum';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $send_email, $send_email_group, $allow_send_email );
</add before>

<search for>
            if (   !${ $uid . $usrname }{'hidemail'}
                || $iamadmin
                || $iamgmod
                || $allow_hide_email != 1 )
            {
                $send_email =
qq~$menusep<a href="mailto:${$uid.$usrname}{'email'}">$img{'email_sm'}</a>~;
            }
</search for>

<replace>

            ### Email Via Forum Mod Edit Start ###
            $allow_send_email = SendEmailPerms();
            if (
                   !${ $uid . $usrname }{'hidemail'}
                || $iamadmin
                || $iamgmod
                || $allow_hide_email != 1
                || (   $send_email
                    && $allow_send_email
                    && ${ $uid . $usrname }{'hidemail'}
                    && ${ $uid . $usrname }{'en_re_email'}
                    && ${ $uid . $username }{'en_send_email'} )
              )
            {
                if (   $send_email
                    && $allow_send_email
                    && ${ $uid . $username }{'en_send_email'} )
                {
                    $send_email =
qq~$menusep<a href="$scripturl?action=sendemail;to=$useraccount{$usrname}">$img{'email_sm'}</a>~;
                }
                else {
                    $send_email =
qq~$menusep<a href="mailto:${$uid.$usrname}{'email'}">$img{'email_sm'}</a>~;
                }
            }
            ### Email Via Forum Mod Edit End ###
</replace>

<search for>
            if (   ${ $uid . $buddyname }{'hidemail'}
                && !$iamadmin
                && $allow_hide_email == 1 )
            {
                $buddyemail =
qq~<img src="$micon_bg{'lockmail'}" alt="$mycenter_txt{'hiddenemail'}" title="$mycenter_txt{'hiddenemail'}" />~;
</search for>

<replace>
            ### Email Via Forum Mod Edit Start ###
            $allow_send_email = SendEmailPerms();
            if (
                (
                       !${ $uid . $buddyname }{'hidemail'}
                    && $send_email
                    && $allow_send_email
                    && ${ $uid . $username }{'en_send_email'}
                )
                || (   ${ $uid . $buddyname }{'hidemail'}
                    && ${ $uid . $buddyname }{'en_re_email'}
                    && $send_email
                    && $allow_send_email
                    && ${ $uid . $username }{'en_send_email'} )
                || (   $iamadmin
                    && $send_email
                    && $allow_send_email
                    && ${ $uid . $username }{'en_send_email'} )
              )
            {
                $buddyemail =
qq~<a href="$scripturl?action=sendemail;to=$useraccount{$buddyname}"><img src="$micon_bg{'email'}" alt="$profile_txt{'889'} ${$uid.$buddyname}{'realname'}" title="$profile_txt{'889'} ${$uid.$buddyname}{'realname'}" /></a>~;
            }
            elsif (${ $uid . $buddyname }{'hidemail'}
                && !$iamadmin
                && $allow_hide_email == 1 )
            {
                $buddyemail =
qq~<img src="$micon_bg{'lockmail'}" alt="$mycenter_txt{'hiddenemail'}" title="$mycenter_txt{'hiddenemail'}" />~;
                ### Email Via Forum Mod Edit End ###
</replace>

<edit file>
Sources/Profile.pm
</edit file>

<search for>
if (@profilepmmods) {
</search for>

<add before>
push @profilepmmods, 'Email via Forum';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our (
    $send_email,  $send_email_group, $allow_send_email,
    $en_re_email, $en_send_email
);
</add before>

<search for>
## Mod Hook showProfile_options ##
</search for>

<add before>
    ### Email Via Forum Mod Edit Start ###
    my $my_en_send_email = q{};
    $allow_send_email = SendEmailPerms();
    if ( $send_email && $allow_send_email ) {
        my $send_checked = q{};
        if ( ${ $uid . $user }{'en_send_email'} ) {
            $send_checked = ' checked="checked"';
        }
        $my_en_send_email = $en_send_email;
        $my_en_send_email =~ s/\Q{yabb send_checked}\E/$send_checked/xsm;
    }
    ### Email Via Forum Mod End ###
    $show_profile =~ s/\Q{yabb my_en_send_email}\E/$my_en_send_email/xsm;
</add before>

<search for>
## Mod Hook showProfile_contacts ##
</search for>

<add before>
    ### Email Via Forum Mod Start ###
    my $my_en_re_email = q{};
    if ( $send_email && $allow_hide_email ) {
        my $re_checked = q{};
        if ( ${ $uid . $user }{'en_re_email'} ) {
            $re_checked = ' checked="checked"';
        }
        $my_en_re_email = $en_re_email;
        $my_en_re_email =~ s/\Q{yabb re_checked}\E/$re_checked/xsm;
    }
    ### Email Via Forum Mod End ###
    $show_profile =~ s/\Q{yabb my_en_re_email}\E/$my_en_re_email/xsm;
</add before>

<search for>
    user_account( $user, 'update' );
    my $newpassemail = get_newemailpass();
</search for>

<add before>
    ### Email Via Forum Mod Start ###
    ${ $uid . $user }{'en_re_email'} = $member{'en_re_email'} ? 1 : 0;
    ### Email Via Forum Mod End ###

</add before>

<search for>
    return;
}

sub chk_profile_sess {
</search for>

<add before>
    ### Email Via Forum Mod Start ###
    ${ $uid . $user }{'en_send_email'} = $member{'en_send_email'} ? 1 : 0;
    ### Email Via Forum Mod End ###
</add before>

<search for>
    if (   !${ $uid . $user }{'hidemail'}
        || $iamadmin
        || !$allow_hide_email
        || $view )
    {
        my $rowemail = q{};
        if ($view) {
            if ( !${ $uid . $user }{'hidemail'} ) {
                $rowemail = $profile_txt{'showingemail'};
            }
            else {
                my ( $admtitle, undef ) =
                  @{ $grp_staff{'Administrator'} };
                $rowemail =
qq~$profile_txt{'notshowingemail'} $admtitle$profile_txt{'notshowingemailend'}~;
            }
        }
</search for>

<replace>
    ### Email Via Forum Mod Edit Start ###
    $allow_send_email = SendEmailPerms();
    if (
           !${ $uid . $user }{'hidemail'}
        || $iamadmin
        || !$allow_hide_email
        || $view
        || (   $send_email
            && $allow_send_email
            && ${ $uid . $user }{'hidemail'}
            && ${ $uid . $user }{'en_re_email'}
            && ${ $uid . $username }{'en_send_email'} )
      )
    {
        my $rowemail = q{};
        if ($view) {
            if ( !${ $uid . $user }{'hidemail'} ) {
                $rowemail = $profile_txt{'showingemail'};
            }
            else {
                my ( $admtitle, undef ) =
                  @{ $grp_staff{'Administrator'} };
                $rowemail =
qq~$profile_txt{'notshowingemail'} $admtitle$profile_txt{'notshowingemailend'}~;
            }
        }
        elsif ($send_email
            && $allow_send_email
            && ${ $uid . $username }{'en_send_email'} )
        {
            $rowemail =
qq~<a href="$scripturl?action=sendemail;to=$useraccount{$user}">$profile_txt{'889'} ${ $uid . $user }{'realname'}</a>~;
        }
        ### Email Via Forum Mod Edit End ###
</replace>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
if (@sublistpmmods) {
</search for>

<add before>
push @sublistpmmods, 'Email via Forum';
</add before>

<search for>
1;
</search for>

<add before>
### Email Via Forum Mod Start ###
$director{'sendemail'} = 'Mods/SendEmail.pm&SendEmail';
$director{'sendemail2'} = 'Mods/SendEmail.pm&SendEmail2';
### Email Via Forum Mod End ###
</add before>

<edit file>
Sources/System.pm
</edit file>

<search for>
if (@systempmmods) {
</search for>

<add before>
push @systempmmods, 'Email via Forum';
</add before>

<search for>
    ## Mod hook ##
</search for>

<add before>
    ### Email Via Forum Mod Start ###
    push @var_tags, 'en_re_email', 'en_send_email';
    ### Email Via Forum Mod End ###
</add before>

<edit file>
Templates/default/MyProfile.template
</edit file>

<search for>
if (@defaultmyprofilemods) {
</search for>

<add before>
push @defaultmyprofilemods, 'Email via Forum';
</add before>

<search for>
    </tr>{yabb my_hidemail}
</search for>

<add after>
    {yabb my_en_re_email}
</add after>

<search for>
{yabb my_time}
</search for>

<add after>
{yabb my_en_send_email}
</add after>

<search for>

1;
</search for>

<add before>

## End Extended Profiles ##
$en_re_email = qq~<tr class="windowbg">
        <td><label for="en_re_email"><b>$profile_txt{'send_email_1'}</b><br /><span class="small">$profile_txt{'send_email_2'}</span></label></td>
        <td><input type="checkbox" name="en_re_email" id="en_re_email"{yabb re_checked} /></td>
    </tr>~;

$en_send_email = qq~<tr class="windowbg">
        <td><label for="en_send_email"><b>$profile_txt{'send_email_3'}</b><br /><span class="small">$profile_txt{'send_email_4'}</span></label></td>
        <td><input type="checkbox" name="en_send_email" id="en_send_email"{yabb send_checked} /></td>
    </tr>~;
</add before>

<edit file>
Help/English/User/user02_profile.help
</edit file>

<search for>
<h4 class="help">ICQ</h4>
</search for>

<add before>
<h4 class="help" id="emailyou">Send Emails via the Forum?</h4>
<p>This is an added option. Check this box if you wish to send e-mails to other members using the forum's e-mail sender. Note: for those members to <strong>receive</strong> e-mails from members using the forum's e-mail sender they must have '<a href="#emailme">Can Members Email you via the Forum?</a>' checked in Options in their profile.</p>
</add before>

<search for>
<h4 class="help">Template</h4>
</search for>

<add before>
<h4 class="help" id="emailme">Can Members Email you via the Forum?</h4>
<p>This is an added option. Check this box if you wish to receive e-mails from other members using the forum's e-mail sender. Note: to <strong>send</strong> e-mails to members using the forum's e-mail sender you must have '<a href="#emailyou">Send Emails via the Forum?</a>' checked in Contact Information in your profile.</p>
</add before>